Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Text
Imports System.Workflow.ComponentModel

Namespace ErrorHandlingInWF
	Public Class LogActivity
		Inherits Activity
		Public Shared ExceptionToLogProperty As DependencyProperty = DependencyProperty.Register("ExceptionToLog", GetType(Exception), GetType(LogActivity))

		<System.ComponentModel.DescriptionAttribute("ExceptionToLog"), System.ComponentModel.CategoryAttribute("ExceptionToLog Category"), System.ComponentModel.BrowsableAttribute(True), System.ComponentModel.DesignerSerializationVisibilityAttribute(System.ComponentModel.DesignerSerializationVisibility.Visible)> _
		Public Property ExceptionToLog() As Exception
			Get
				Return (CType(MyBase.GetValue(LogActivity.ExceptionToLogProperty), Exception))
			End Get
			Set(ByVal value As Exception)
				MyBase.SetValue(LogActivity.ExceptionToLogProperty, value)
			End Set
		End Property

		Protected Overrides Function Execute(ByVal executionContext As ActivityExecutionContext) As ActivityExecutionStatus
			Console.ForegroundColor = ConsoleColor.Red

			Console.WriteLine(ExceptionToLog.Message)

			Console.ResetColor()
			Return ActivityExecutionStatus.Closed
		End Function
	End Class
End Namespace
