Imports Microsoft.VisualBasic
Imports System
Imports System.ComponentModel
Imports System.ComponentModel.Design
Imports System.Collections
Imports System.Drawing
Imports System.Linq
Imports System.Workflow.ComponentModel.Compiler
Imports System.Workflow.ComponentModel.Serialization
Imports System.Workflow.ComponentModel
Imports System.Workflow.ComponentModel.Design
Imports System.Workflow.Runtime
Imports System.Workflow.Activities
Imports System.Workflow.Activities.Rules

Namespace ErrorHandlingInWF
    Partial Public NotInheritable Class ManualRetryLogic
        Inherits SequentialWorkflowActivity
        Private retryFlag As Boolean = True
        Private hasExceptionOccured As Boolean = False


        Public Sub New()
            InitializeComponent()
        End Sub

        Public Shared customThrowIndicatorProperty As DependencyProperty = DependencyProperty.Register("customThrowIndicator", GetType(System.Int32), GetType(ErrorHandlingInWF.ManualRetryLogic))

        <DesignerSerializationVisibilityAttribute(DesignerSerializationVisibility.Visible), BrowsableAttribute(True), CategoryAttribute("Retry")> _
        Public Property customThrowIndicator() As Int32
            Get
                Return (CInt(Fix(MyBase.GetValue(ErrorHandlingInWF.ManualRetryLogic.customThrowIndicatorProperty))))
            End Get
            Set(ByVal value As Int32)
                MyBase.SetValue(ErrorHandlingInWF.ManualRetryLogic.customThrowIndicatorProperty, value)
            End Set
        End Property

        Private Sub CheckThrowResult(ByVal sender As Object, ByVal e As ConditionalEventArgs) Handles codecondition1.Condition
            e.Result = Not hasExceptionOccured
        End Sub

        Private Sub TurnOffRetry_ExecuteCode(ByVal sender As Object, ByVal e As EventArgs) Handles TurnOffRetry.ExecuteCode
            retryFlag = False
        End Sub

        Private Sub EnsureRetry_ExecuteCode(ByVal sender As Object, ByVal e As EventArgs) Handles EnsureRetry.ExecuteCode
            retryFlag = True
            hasExceptionOccured = False
        End Sub

        Private Sub codeActivity1_ExecuteCode(ByVal sender As Object, ByVal e As EventArgs) Handles codeActivity1.ExecuteCode
            hasExceptionOccured = True
        End Sub
    End Class

End Namespace
